"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var Jed = require("jed");
var React = require("react");
var JedPureComponent = /** @class */ (function (_super) {
    tslib_1.__extends(JedPureComponent, _super);
    // Any is neccessary here
    // tslint:disable-next-line no-any
    function JedPureComponent(props, context) {
        var _this = _super.call(this, props, context) || this;
        _this.i18n = new Jed({});
        // This promise is self-handled
        // tslint:disable-next-line no-floating-promises
        _this.initLanguage();
        return _this;
    }
    JedPureComponent.prototype._ = function (msgid) {
        return this.i18n.gettext.apply(this.i18n, arguments);
    };
    JedPureComponent.prototype.ngettext = function (msgid, msgidPlural, value) {
        return this.i18n.ngettext.apply(this.i18n, arguments);
    };
    JedPureComponent.prototype.initLanguage = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var propCallback, languageLoadedCallback, l, e_1;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        propCallback = this.props.languageLoadedCallback;
                        languageLoadedCallback = typeof propCallback === "function" ? propCallback : (function (err) {
                            if (err !== undefined && window.hasOwnProperty("console")) {
                                // We don't want silient failure
                                // tslint:disable-next-line no-console
                                console.warn(err);
                            }
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.getTranslation()];
                    case 2:
                        l = _a.sent();
                        if (l === undefined) {
                            languageLoadedCallback(undefined, false);
                            return [2 /*return*/];
                        }
                        this.i18n = new Jed(l);
                        this.forceUpdate();
                        languageLoadedCallback(undefined, true);
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        languageLoadedCallback(e_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    return JedPureComponent;
}(React.PureComponent));
exports.JedPureComponent = JedPureComponent;
